<?php
/*
This file is part of Shokado Web Sharing Tool for Bento.

Shokado Web Sharing Tool for Bento is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Shokado Web Sharing Tool for Bento is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with Shokado Web Sharing Tool for Bento.  If not, see <http://www.gnu.org/licenses/>.
*/



/* Main Functions */
$currentTagName = "";


function GetImageFromResources($libraryID, $iconSet, $libType) {
 
	if ( $libType=="GNLibraryControllerAddressBook") {
		$imgName= getImageName("com.filemaker.bento.datasource.addressbook.contacts");
		$libImgname= $libraryID . ".png";
	 	copy ($imgName, $libImgname);
	 	return true;
	}
	if ( $libType=="GNLibraryControllerCalEvent") {
		$imgName= getImageName("com.filemaker.bento.datasource.ical.events");
		$libImgname= $libraryID . ".png";
	 	copy ($imgName, $libImgname);
	 	return true;
	}
	if ( $libType=="GNLibraryControllerCalTask") {
		$imgName= getImageName("com.filemaker.bento.datasource.ical.tasks");
		$libImgname= $libraryID . ".png";
	 	copy ($imgName, $libImgname);
	 	return true;
	}

    if ($iconSet!=null) {
		global $db;
		$imgResult = $db->query("SELECT gn_identifier  from gn_iconset where gnpk=".$iconSet); //com.filemaker.bento.iconset.projects
		$imgrow = $imgResult->fetch(PDO::FETCH_ASSOC);

		if ($imgrow)  {
			$imgInfo = $imgrow["gn_identifier"];
			$imgName= getImageName($imgInfo);
			$libImgname= $libraryID . ".png";
			copy ($imgName, $libImgname);
			return true;
		}
	}
	else {
		$imgName= getImageName("");
		$libImgname= $libraryID . ".png";
	 	copy ($imgName, $libImgname);
	 	return true;
	}
}

function getImageName($info) {
	global $bentoApp;
	$imgLocation = $bentoApp . "/Contents/Resources/Icons/";
	
	switch($info) {
		case "com.filemaker.bento.iconset.homeinventory":
			$imgLocation.="Home Inventory.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.digital_media":
			$imgLocation.="Digital Media.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.generic":
			$imgLocation.="Generic.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.notes":
			$imgLocation.="Notes.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.projects":
			$imgLocation.="Projects.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.vehicles":
			$imgLocation.="Vehicles.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.datasource.addressbook.contacts":
			$imgLocation.="Contacts.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.datasource.ical.events":
			$imgLocation.="Events.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.datasource.ical.tasks":
			$imgLocation.="To Do.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.classes":
			$imgLocation.="Classes.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.customers":
			$imgLocation.="Customers.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.diet_log":
			$imgLocation.="Diet Log.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.donations":
			$imgLocation.="Donations.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.equipment":
			$imgLocation.="Equipment.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.eventplanning":
			$imgLocation.="Event Planning.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.events":
			$imgLocation.="Events.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.exerciselog":
			$imgLocation.="Exercise Log.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.expenses":
			$imgLocation.="Expenses.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.files":
			$imgLocation.="Files.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.inventory":
			$imgLocation.="Inventory.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.issuetracking":
			$imgLocation.="Issue Tracking.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.itemssold":
			$imgLocation.="Items Sold.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.membershiplist":
			$imgLocation.="Memebership List.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.notes":
			$imgLocation.="Notes.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.productsforsale":
			$imgLocation.="Products For Sale.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.recipes":
			$imgLocation.="Recipes.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.studentlist":
			$imgLocation.="Students List.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.timebilling":
			$imgLocation.="Time Billing.bentoicon/library_large.png";
			break;
		case "com.filemaker.bento.iconset.todo":
			$imgLocation.="To Do.bentoicon/library_large.png";
			break;

		default :
			$imgLocation.="Generic.bentoicon/library_large.png";
		break;
	}
	
	return $imgLocation;
	
}

function GetImageFromDB($libraryID) {
	global $db;
	$imgResult = $db->query("SELECT gn_libraryIcon from gn_iconset WHERE gn_library=".$libraryID);
	$imgrow = $imgResult->fetch(PDO::FETCH_ASSOC);
	if ($imgrow)  {
		$imgInfo = $imgrow["gn_libraryIcon"];
	 	doParse($imgInfo);
	 	return true;
	}
	else {
		return false;
	}
}

function GetCollImageFromDB($libraryID) {
	global $db;
	$imgResult = $db->query("SELECT gn_libraryIcon from gn_iconset WHERE gn_library=".$libraryID);
	$imgrow = $imgResult->fetch(PDO::FETCH_ASSOC);
	if ($imgrow)  {
		$imgInfo = $imgrow["gn_libraryIcon"];
		doParse($imgInfo);
		return true;
	}
	else {
		return false;
	}
}
		
/*XML processing functions*/
function characterData($parser,$data) {
	global $currentTagName;
	if ($currentTagName=="DATA"){
		outputImage($data);
	}
}
	
function startElement($parser,$name,$atts) {
	global $currentTagName;
	$currentTagName  = $name;
}
	
function endElement($parser,$name) {
	global $currentTagName;
	$currentTagName="";
}

function doParse($xml) {
	$xmlparser = xml_parser_create();
	xml_set_element_handler($xmlparser, 'startElement', 'endElement');
	xml_set_character_data_handler($xmlparser, 'characterData');
	xml_parse($xmlparser, $xml);
	xml_parser_free($xmlparser);
}
	
/*Image processing functions*/
function saveImage($data){
	global $imageType;
	global $libraryImageName;
	global $collectionImageName;
	
	if ($imageType=="Library") {
		$libraryFileName = getcwd() . "/". $libraryImageName;
	}
	else {
		$libraryFileName = getcwd() . "/". $collectionImageName;
	}
	$fh=fopen($libraryFileName,"w");
	fwrite($fh,$data);
	fclose($fh);
}
	
function outputImage($imgcode){
	saveImage(base64_decode($imgcode));
}

?>